#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include <avr/boot.h>

//#include <util/crc16.h>

#include "protocol.h"

#ifndef UBRRL
#define UBRRL UBRR1L
#endif
#ifndef UBRRH
#define	UBRRH UBRR1H
#endif
#ifndef UCSRA
#define	UCSRA UCSR1A
#endif
#ifndef UCSRB
#define UCSRB UCSR1B
#endif
#ifndef UCSRC
#define	UCSRC UCSR1C
#endif
#ifndef UDR
#define UDR UDR1
#endif

#ifndef UDRE
#define UDRE UDRE1
#endif

#define elpm(addr) ({					\
	register unsigned char t;			\
	asm volatile (					\
		"elpm" "\n"				\
		"mov    %0,r0"				\
		: "=r" (t)				\
		: "z" ((short)addr));			\
	t; })

	
asm("cli");

int main()
{
	unsigned char buff[SPM_PAGESIZE]; //   
	unsigned char i,cmd;
	unsigned int addr;
//	unsigned int crc;
			
	// init uart
	UBRRL = 5; // 115200 bps
	UBRRH = 0;
	UCSRA = 0x00;
	UCSRC = 0x06;
	UCSRB = _BV(RXEN) | _BV(TXEN);

	TCCR0=0; // stop timer
	OCR0  = 30*4;  // byte * 4
	TIMSK  = 0; // disable timer interrupt
	TIFR = TIFR; // clear all signal

	_wdt_write(WDTO_60MS);
	wdt_reset();

	loop_until_bit_is_set(UCSRA,UDRE);
	UDR='B';
	loop_until_bit_is_set(UCSRA,UDRE);
	UDR='o';
	loop_until_bit_is_set(UCSRA,UDRE);
	UDR='o';
	loop_until_bit_is_set(UCSRA,UDRE);
	UDR='t';

	while(1)
	{
		addr=0;

		if(bit_is_set(TIFR,OCF0))
			TIFR = _BV(OCF0);

		TCCR0=0;
		
		while(bit_is_clear(UCSRA,RXC))
			wdt_reset();

		cmd=UDR;

//		loop_until_bit_is_set(UCSRA,UDRE);
//		UDR=0xA5;
		
		TCNT0 = 0;
		TCCR0= _BV(CS01) | _BV(CS00); // run timer0

		while(bit_is_clear(UCSRA,RXC) && bit_is_clear(TIFR,OCF0) ); // 祪   ⠩				
		if(bit_is_set(TIFR,OCF0))
			continue;

		TCNT0=0;
		RAMPZ=UDR;				

//		loop_until_bit_is_set(UCSRA,UDRE);
//		UDR=RAMPZ;


		while(bit_is_clear(UCSRA,RXC) && bit_is_clear(TIFR,OCF0) ); // 祪   ⠩			
		if(bit_is_set(TIFR,OCF0))
			continue;
			
		TCNT0=0;		
		((char*)&addr)[1]=UDR;

//		loop_until_bit_is_set(UCSRA,UDRE);
//		UDR=((char*)&addr)[1];
		
		if(cmd==CMD_WRITEPAGE)
		{
	
			i=0;
			do
			{
				while(bit_is_clear(UCSRA,RXC) && bit_is_clear(TIFR,OCF0) ); // 祪   ⠩			
			
				if(bit_is_clear(TIFR,OCF0))
				{
					buff[i]=UDR;			
					TCNT0=0;
				}
				else
					break;
				++i;
			} while(i);
		
			TCCR0=0;

			if(bit_is_set(TIFR,OCF0))
				continue;
						
        	boot_page_erase (addr);
	        boot_spm_busy_wait ();      // Wait until the memory is erased.

//    	    for (i=0; i<SPM_PAGESIZE; i+=2)
			i=0;
			do
        	{
        	    boot_page_fill (addr + i, ((int*)buff)[i/2]);
        	    i+=2;
	        } while(i);

    	    boot_page_write (addr);     // Store buffer in flash addr.
        	boot_spm_busy_wait();       // Wait until the memory is written.

	        // Reenable RWW-section again. We need this if we want to jump back
    	    // to the application after bootloading.

	        boot_rww_enable ();

			loop_until_bit_is_set(UCSRA,UDRE);
			UDR=-1;
		}		

		else if(cmd==CMD_READPAGE)
		{
			TCCR0=0;
			i=0;
			do{
				cmd=elpm(addr+i);							
				loop_until_bit_is_set(UCSRA,UDRE);
				UDR=cmd;
				++i;
			}while(i);
			continue;
		}
		else if(cmd==CMD_RESET)
		{
			loop_until_bit_is_set(UCSRA,UDRE);
			UDR=cmd;
			while(1); // 横  १ ஦ ⠩஬
		}

	
	}
	return 0;
}

